from pycel import *
from apricotpc import ApricotPropertyClass, NoneParBlock

class SensorProperty(ApricotPropertyClass):
    """
    cel property class
    Synchronizing property.
    """

    def __init__(self,oreg):
        ApricotPropertyClass.__init__(self,oreg)
        pyPcPropertyListener.__init__(self,oreg)
        self.target = None
        self.pc = None
        self.listen_prop = None
        self.target_prop = None

    def SetEntity(self,celEntity):
        ApricotPropertyClass.SetEntity(self,entity)
        if not entity: return
        self.prop = celProperties(entity)

    def SetProperty(self,id,val):
        # XXX SetProperty override not supported!!!
        # not fixing cos doesnt seem this works...
        res = pyPcCommon.SetProperty(self,id,val)
        if self.target and self.pc and self.target_prop and self.listen_prop:
            self.Activate()
        return res

    def Activate(self):
        pcprop = celProperties(Entities[self.target]).AddPropertyListener(self)

    def PropertyChanged(self,pcprop,idx):
        name = pcprop.GetPropertyName(idx)
        if name == self.listen_prop:
            pc = self.entity.PropertyClassList.FindByName(self.pc).SetProperty(propid(self.target_prop),str(pcprop[idx]))
        pass

CEL_IMPLEMENT_FACTORY(SensorProperty,"apricot.sensor.property")

